/*
 *  globals.c - Definitions of all global variables.
 *
 *  (C) 1994, 1995 Mikael Nordqvist (d91mn@efd.lth.se, mech@df.lth.se)
 */

#include "mod.h"

/* The module */

struct mod_info M;

/* Sound-device */

int seqfd, mixerfd, gus_dev;
char *mixer_name;
char mixer_namebuf[80];

/* Variables used to play module */

struct voice V[MAX_VOICES];
struct effects efx;
struct event *cur_event;

int songpos, linepos, tick, speed, tempo;
double mod_time, tick_time;
char is_first_ult_effect;

char song_end, restart_song, advance_songpos;

/* Variables for commands requiring player to back up */

int last_speed, last_tempo, last_pos, last_line;

/* Options */

struct options  default_opt;  /* Default options */
struct options  opt;          /* Current module options */

/* Misc variables */

int total_time, restart_time, starting_time;
char maxtime_done;  /* True when song was stopped after maxtime */
int maxfd;

char *exe_name;
char workdir[PATH_MAX+1];      /* The current directory mod is in    */
char startup_dir[PATH_MAX+1];  /* The directory mod was started from */
char playlist_name[PATH_MAX+1];/* Current playlists name for ncurses */

int GUI_mode;             /* Default to simple GUI */
int GUI_size;             /* Default size for window in X */
int quit;                 /* Set when program is aborting */
int suspend;              /* True when we are about to suspend the process */
int quiet;

int loaded;               /* True when a module has been loaded     */
int loaded_list;          /* True when loaded mod is from the list  */
int playing;              /* True when music is being played        */
int selecting;            /* True when we are in load/filelist mode */
int selecting_list;       /* True = filelist, False = load mode     */

/* Communication */

int ack_pipe[2];           /* Player sends acks to main through this one */
int player2main_synced[2]; /* Message from player to main (synced) */
int main2player[2];        /* Message from main to player */

pid_t pid_main, pid_player;

/* Lists */

struct list_head Playlist;
struct list_head *PL;

/* Files */

struct mod_file *files;   /* Array of files */
char *file_names;         /* Space to store filenames in */

int nr_files;   /* Includes directories */
int nr_dirs;    /* Directories only     */
int cur_filenr; /* Current file */
int cur_listnr; /* Current file */

int loaded_filenr; /* Currently loaded file */
