/*
 *  help.c - Help and usage texts.
 *
 *  (C) 1994, 1995 Mikael Nordqvist (d91mn@efd.lth.se, mech@df.lth.se)
 */

#include <stdio.h>
#include "mod.h"

static char *global_help[]={
    "-A        Don't autoload next song",
    "-b        Browse mode",
    "-C        Cyclic play of modules",
    "-d        Dump songdata",
    "-D <arg>  Set startup directory",
    "-h        Help",
    "-i <arg>  Set interface",
    "-I <arg>  Set window size",
    "-k        Kill mod in background",
    "-l <arg>  Number of scroll lines",
    "-n        Disable scrolling",
    "-P <arg>  Load playlist",
    "-q        Quiet mode",
    "-Q        Totally quiet mode",
    "-r        Play modules randomly",
    "-v        Verbose mode",
    "-X <arg>  Visible path components",
    "-y <arg>  Output device (N/A yet)",
    "-Y <arg>  Mixer device",
    "-z        Put mod in background",
    "-Z        Allow deletion of files",
    0
};

static char *local_help[]={
    "-B        Don't break loops",
    "-c <arg>  Click removal",
    "-f <arg>  Module format",
    "-F <arg>  Mixing frequency (N/A yet)",
    "-L        Loop module",
    "-m <arg>  Maximum moduletime",
    "-M        Mono output",
    "-N        NTSC-amiga samplepitch",
    "-o        Octaves 1-3",
    "-O        Octaves 0-7",
    "-p <arg>  Startposition",
    "-s <arg>  Set speed",
    "-S <arg>  Set stop position",
    "-t <arg>  Set tempo",
    "-T        Tolerant mode",
    "-x <arg>  Detail of voice information",
    "-0        Ignore changes to speed 0",
    "-5        PAL-amiga (50 Hz) tempo",
    "-6        NTSC-amiga (60 Hz) tempo",
    0
};

/* Options unused: 1234789aeEgGHIjJKRuUV */

void print_helptext(void)
{
    printf("mod %s Copyright (C) 1994, 1995 Mikael Nordqvist.\n\n"
	   "Usage: %s [global options] file [options] file [options] ...\n\n"
	   "Options always global:\n\n", MOD_VERSION, exe_name);
    print_options(global_help);
    printf("\nModule-specific options:\n\n");
    print_options(local_help);
}

void print_options(char *options[])
{
    int i, j, nr;

    for(nr=0; options[nr]; ++nr)
	;
    
    j=nr/2+nr%2;
    for(i=0; i < nr/2; ++i, ++j)
	printf("  %-37s   %-37s\n", options[i], options[j]);
    if(nr%2)
	printf("  %-37s\n", options[i]);
}
