/*
 *  simple_controller.c - Controller for the simple interface.
 *
 *  (C) 1994, 1995 Mikael Nordqvist (d91mn@efd.lth.se, mech@df.lth.se)
 */

#include <unistd.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <errno.h>

#include "mod.h"
#include "lists.h"
#include "message.h"


void simple_init_controller(void)
{
    L_order_reset(PL);
    load_next(1, 1, 1); /* Exit after last song, and be persistent */
}


void simple_end_of_song(void)
{
    simple_print(0);
    load_next(1, 1, 1); /* Exit after last song, and be persistent */
}


void simple_read_key(void)
{
    char ch;

    read(STDIN_FILENO, &ch, 1);
    
    switch(ch) {
      case 'q':
	simple_print(0);
	command_player(MESSAGE_EXIT, 42);
	quit=QUIT_QUIT;
	break;
      case '+':
	change_mastervolume(5);
	break;
      case '-':
	change_mastervolume(-5);
	break;
      case 'm':	
	toggle_mute();
	break;
      case 'f':
	command_player(MESSAGE_JUMPPATTERN, MIN(last_pos+1, M.songlength-1));
	break;
      case 'b':
	command_player(MESSAGE_JUMPPATTERN, MAX(last_pos-1, 0));
	break;
      case 'r':
	command_player(MESSAGE_JUMPPATTERN, opt.start_pos);
	break;
      case ' ':
	simple_print(0);
	load_next(1, 1, 1); /* Exit after last song, and be persistent */
	break;
      case 'n':
	/* Exit after last song only if the last song failed to load.
	 * Be persistent.
	 */
	simple_print(0);
	load_next(0, 1, 1);
	break;
      case 'p':
	simple_print(0);
	load_prev(0, 1, 1);
	break;
      default:
    }
}
