
################### Loader screen ##################

proc show_load {} {
    global largefont bgcol load_active oldfocus first_filenr first_listnr\
	    w_load w_loadslim w_loadchubby w_menu_file w_menu_file_nr_load
    
    # Make sure a second click is ignored.
    if {[expr $load_active]} {
	return
    } else {
	set load_active 1
	$w_load configure -state disabled
	$w_loadslim configure -state disabled
	$w_loadchubby configure -state disabled
	$w_menu_file entryconfigure $w_menu_file_nr_load -state disabled
    }
    
    toplevel .l
    wm title .l "Mod fileselector"
    wm protocol .l WM_DELETE_WINDOW {.l.done invoke}
    wm resizable .l no no
    
    # File window
    
    frame .l.f -bd 2 -relief raised

    frame .l.fileboxx
    frame .l.filewin
    frame .l.files
    listbox .l.filebox -width 30 -height 15 -relief sunken -bd 2\
	    -yscroll "scany_filepos" -xscroll ".l.filexscroll set"
    scrollbar .l.filexscroll -orient horizontal -width 15 -relief sunken\
	    -command ".l.filebox xview"
    pack .l.filebox .l.filexscroll -in .l.fileboxx -side top -fill x\
	    -expand yes
    scrollbar .l.filescroll -orient vertical -width 15 -relief sunken\
	    -command "change_filepos"
    pack .l.fileboxx .l.filescroll -in .l.files -side left -fill y

    bind .l.filebox <Double-Button-1> {
	set nr [eval {%W nearest %y}]
	set name [.l.filebox get $nr]
	set len [string length $name]
	if {[expr [string compare ".lst" [string range $name [expr $len-4] \
		[expr $len-1]]]	== 0]} {
	    .l.loadlist invoke
	} else {
	    c_loadfile $nr
	}
	if {[expr $browse_state == 1]} {
	    update
	    .l.filebox selection clear 0 end
	}
	break
    }
    
    button .l.filelabel -textvariable m_load_dir -relief raised -bd 2\
	    -padx 4 -pady 2 -command {
	global c2tcl
	
	c_setcwd
	set a [ask_string "Directoy change" "Please enter new directory." \
		$c2tcl 0]
	if {[expr [string compare $a ""] != 0]} {
	    c_change_dir $a
	}
    }

    frame .l.filebuttons
    button .l.load -text "Load" -command {
	global nr_dirs
	load_marked ".l.filebox" "c_loadfile" $nr_dirs
    }

    button .l.delete -text "Delete" -state disabled -command {
	set list [.l.filebox curselection]
	set len [llength $list]
	if {[expr $len > 1]} {
	    show_message "Message" "You have selected more than one file. \
		    Please make sure only one file is selected." 200
	} elseif {[expr $len == 1]} {
	    c_deletefile [lindex $list 0]
	    .l.filebox selection clear 0 end
	}
    }

    button .l.markall -text "Mark all" -command {
	global nr_files nr_dirs
	if {[expr $nr_files > $nr_dirs]} {
	    .l.filebox selection set $nr_dirs $nr_files
	}
    }
    pack .l.load .l.delete .l.markall -in .l.filebuttons -side left\
	    -expand yes -padx 4 -fill x

    pack .l.filelabel   -in .l.filewin -padx 4 -pady 4 -expand yes -fill x
    pack .l.files       -in .l.filewin -padx 4 -pady 4 -expand yes
    pack .l.filebuttons -in .l.filewin -padx 4 -pady 4 -expand yes -fill x

    # List window

    frame .l.listboxx
    frame .l.listwin
    frame .l.list
    listbox .l.listbox -width 30 -height 15 -relief sunken -bd 2\
	    -yscroll "scany_listpos"  -xscroll ".l.listxscroll set"
    scrollbar .l.listxscroll -orient horizontal -width 15 -relief sunken\
	    -command ".l.listbox xview"
    pack .l.listbox .l.listxscroll -in .l.listboxx -side top -fill x\
	    -expand yes
    scrollbar .l.listscroll -orient vertical -width 15 -relief sunken\
	    -command "change_listpos"
    pack .l.listboxx .l.listscroll -in .l.list -side left -fill y -expand yes

    bind  .l.listbox <Double-Button-1> {
	c_loadlistfile [eval {%W nearest %y}]
	if {[expr $browse_state == 1]} {
	    .l.listbox selection clear 0 end
	}
	break
    }
    
    label .l.listlabel -text "Playlist" -relief raised -bd 2\
	    -padx 4 -pady 2

    frame .l.listbuttons
    button .l.playlist -text "Load" -command {
	load_marked ".l.listbox" "c_loadlistfile" 0
    }
    button .l.remove -text "Remove" -command {
	c_removelistfiles [lsort -integer [.l.listbox curselection]]
    }
    button .l.markallist -text "Mark all" -command {
	if {[expr $nr_listfiles > 0]} {
	    .l.listbox selection set 0 end
	}
    }
    pack .l.playlist .l.remove .l.markallist -in .l.listbuttons -side left\
	    -expand yes -ipadx 10

    pack .l.listlabel   -in .l.listwin -padx 4 -pady 4 -expand yes -fill x
    pack .l.list        -in .l.listwin -padx 4 -pady 4 -expand yes
    pack .l.listbuttons -in .l.listwin -padx 4 -pady 4 -expand yes -fill x


    # Middle window

    frame .l.buttons

    checkbutton .l.browse -text "Browse" -variable browse_state -relief raised\
	    -padx 4 -pady 2 -command {c_toggle_browse $browse_state}
    checkbutton .l.random -text "Random" -variable random_state -relief raised\
	    -padx 4 -pady 2 -command {c_toggle_random $random_state}
    button .l.append -text "Append" -command {
	global nr_listfiles
	c_listinsertnr 1 [expr $nr_listfiles-1]\
		[lsort -integer [.l.filebox curselection]]
    }
    button .l.prepend -text "Prepend" -command {
	global nr_listfiles
	c_listinsertnr 0 0 [lsort -integer [.l.filebox curselection]]
    }
    button .l.insert -text "Insert" -command {
	global inserting fgcol lightfgcol
	if {[expr $inserting == 0]} {
	    .l.insert configure -fg $lightfgcol\
		    -activeforeground $lightfgcol
	    .l.insert configure -text "Where ?"
	    bind .l.listbox <Button-1> {
		c_listinsertnr 0 [eval {%W nearest %y}]\
			[lsort -integer [.l.filebox curselection]]
		.l.insert invoke
		break
	    }
	    set inserting 1
	} else {
	    .l.insert configure -fg $fgcol -activeforeground $fgcol
	    .l.insert configure -text "Insert"
	    set inserting 0
	    bind .l.listbox <Button-1> {}
	    update
	    .l.listbox selection clear 0 end
	}
    }
    button .l.dotdot -text ".." -command {
	if {[expr [string compare [.l.filebox get 0] "../"] == 0]} {
	    c_loadfile 0
	}
    }

    button .l.viewtext -text "View file" -command {
	global nr_dirs
	load_marked ".l.filebox" "view_textfile" $nr_dirs
    }
    
    button .l.edit -text "Edit options" -command {
	set a [lsort -integer [.l.listbox curselection]]
	if {[expr [string compare $a ""] != 0 && [.l.listbox size] != 0]} {
	    edit_module_options  $a
	    .l.listbox selection clear 0 end
	}
    }
    button .l.loadlist -text "Load list" -command {
	if {[expr $nr_listfiles > 0]} {
	    ask_left_right "Load list" \
		    "Loading a playlist means any changes to \
your current playlist will be discarded.

Do you wish to continue?" "Yes" "Cancel" 300
            if {[expr $ask_left_right_result]} {
		return
	    }
        }
	set list [lsort -integer [.l.filebox curselection]]
	set len [llength $list]
	if {[expr $len == 0]} {
	    global c2tcl
	    
	    c_setcwd
	    set default $c2tcl/.lst
	    set offset 5
	    c_setlistname
	    if {[expr [string compare $c2tcl ""] != 0]} {
		set default $c2tcl
		set offset 0
	    }
	    set a [ask_string "Load playlist" \
		    "Please enter filename for playlist." $default $offset]
	    if {[expr [string compare $a ""] != 0]} {
		c_load_playlist 0 $a
	    }
	} elseif {[expr $len > 1]} {
	    show_message "Message" "You have selected more than one file. \
		    Please make sure only one file is selected." 200
	} else {
	    c_load_playlist 1 [lindex $list 0]
	    .l.filebox selection clear 0 end
	    .l.listbox xview 0
	}
    }
    button .l.savelist -text "Save list" -command {
	if {[expr $nr_listfiles > 0]} {
	    global c2tcl
	    
	    c_setcwd
	    set default $c2tcl/.lst
	    set offset 5
	    c_setlistname
	    if {[expr [string compare $c2tcl ""] != 0]} {
		set default $c2tcl
		set offset 0
	    }
	    set a [ask_string "Save playlist" \
		    "Please enter filename for playlist." $default $offset]
	    if {[expr [string compare $a ""] != 0]} {
		c_save_playlist $a
	    }
	}
    }
    button .l.done -text "Done" -command {
	global load_active inserting first_filenr first_listnr\
		w_load w_loadslim w_loadchubby w_menu_file w_menu_file_nr_load

	set first_filenr [lindex [.l.filescroll get] 2]
	set first_listnr [lindex [.l.listscroll get] 2]
	destroy .l
	set load_active 0
	set inserting 0
	c_unshowload
	$w_load configure -state normal
	$w_loadslim configure -state normal
	$w_loadchubby configure -state normal
	$w_menu_file entryconfigure $w_menu_file_nr_load -state normal
	update
	update idletasks
    }

    frame .l.a
    frame .l.b
    frame .l.c
    frame .l.d

    pack .l.browse .l.random -in .l.buttons \
	    -fill x -ipadx 10 -pady 4 -padx 10
    pack .l.a -in .l.buttons -expand yes
    pack .l.append .l.prepend .l.insert -in .l.buttons \
	    -fill x -ipadx 10 -pady 2 -ipady 3 -padx 10
    pack .l.b -in .l.buttons -expand yes
    pack .l.dotdot -in .l.buttons \
	    -fill x -ipadx 10 -ipady 3 -padx 10
    pack .l.c -in .l.buttons -expand yes
    pack .l.viewtext .l.edit .l.loadlist .l.savelist -in .l.buttons \
	    -fill x -ipadx 10 -pady 2 -padx 10
    pack .l.d -in .l.buttons -expand yes
    pack .l.done -in .l.buttons \
	    -fill x -ipadx 10 -pady 4 -padx 10

    # Pack the windows

    pack .l.filewin .l.buttons .l.listwin -fill y -side left -in .l.f
    pack .l.f

    update
    c_load
    change_listpos $first_listnr
    change_filepos $first_filenr

    # Set up bindings

    bind .l <Escape> {.l.done invoke}
    bind .l l {.l.done invoke}
    bind .l a {.l.append invoke}
    bind .l p {.l.prepend invoke}
    bind .l i {.l.insert invoke}
    bind .l <Delete> {.l.remove invoke}
    bind .l <Insert> {.l.append invoke}
    bind .l r {.l.random invoke}
    bind .l b {.l.browse invoke}
    bind .l u {.l.dotdot invoke}
    bind .l D {.l.delete invoke}

#    bind .l <Enter> {focus .l}
    focus .l
}

### Options editing

proc edit_options {} {
    global e_name e_nr edit_list
    
    set edit_list [lsort -integer [.l.listbox curselection]]
    if {[expr [llength $edit_list] == 0]} {
	set edit_list [list -1]
	set mess "
Please enter global options for the playlist.
	
(If you want to set options for individual modules you have to select \
them first)."

    } else {
	set mess "Please enter options for module"
    }

    toplevel .e -relief raised -bd 2
    wm title .e "Edit options"
    wm protocol .e WM_DELETE_WINDOW {edit_done}
    wm resizable .e no no
    grab .e
    
    message .e.text -justify center -aspect 350\
	    -text $mess
    label .e.name -textvariable e_name
    entry .e.entry -relief sunken -width 25
    button .e.done -text "Done" -command {edit_next}

    bind .e.entry <Return> {.e.done invoke}
    bind .e.entry <Escape> {edit_done}
    bind .e <Enter> {focus .e.entry}

    pack .e.text .e.name -padx 10 -pady 5
    pack .e.entry -padx 15
    pack .e.done -fill x -pady 5 -padx 5
    focus .e.entry
    show_options
}

proc edit_next {} {
    global edit_list e_nr

    c_set_options $e_nr [.e.entry get]
    if {[expr [llength $edit_list] == 0]} {
	edit_done
	return
    }
    show_options
}

proc show_options {} {
    global edit_list e_name e_nr

    .e.entry delete 0 end
    set e_nr [lindex $edit_list 0]
    if {[expr $e_nr != -1]} {
	set e_name [.l.listbox get $e_nr]
    } else {
	set e_name ""
    }
    c_display_options $e_nr
    set edit_list [lreplace $edit_list 0 0]
}

proc edit_done {} {
    destroy .e
    .l.listbox selection clear 0 end
}

### Text viewer

proc view_textfile {filenr} {
    global c2tcl

    set filename [.l.filebox get $filenr]
    c_access $filename
    if {[expr $c2tcl]} {
	set fileid [open $filename "r"]
	view_text "Contents of '$filename'" [read $fileid]
	close $fileid
    }
}

proc view_text {wintitle txt} {
    global fixfont

    toplevel .textwin
    grab .textwin
    focus .textwin
    wm title .textwin $wintitle
    wm protocol .textwin WM_DELETE_WINDOW {.textwin.b invoke}
    wm resizable .textwin no no
    frame .textwin.f
    text .textwin.f.t -width 80 -height 25 -font $fixfont -relief raised\
	    -bd 2 -yscroll "scany_textpos"
    .textwin.f.t insert 0.0 $txt
    .textwin.f.t configure -state disabled
    scrollbar .textwin.f.yscroll -orient vertical -width 15 -relief sunken\
	    -command "change_textpos"
    button .textwin.b -text "Done" -command {destroy .textwin}
    pack .textwin.f.t .textwin.f.yscroll -side left -fill y
    pack .textwin.f .textwin.b -fill x
    bind .textwin <Return> {.textwin.b invoke}
    bind .textwin <Escape> {.textwin.b invoke}
    tkwait window .textwin
}

proc change_textpos {pos} {
    scan [.textwin.f.t index end]] "%d." lines
    if {[expr $pos >= $lines-25]} {set pos [expr $lines-25]}
    if {[expr $pos < 0]} {set pos 0}
    .textwin.f.yscroll set $lines 25 $pos [expr $pos+24]
    .textwin.f.t yview $pos
}

# Why doesn't scan work on text-widgets?!?!

proc scany_textpos {a b} {
    scan [.textwin.f.t index end]] "%d." lines
    change_textpos [expr round($a*$lines)]
}

### Various functions

# If user requests a change of filepos.

proc change_filepos {pos} {
    global nr_files
    if {[expr $pos >= $nr_files-15]} {set pos [expr $nr_files-15]}
    if {[expr $pos < 0]} {set pos 0}
    .l.filescroll set $nr_files 15 $pos [expr $pos+14]
    .l.filebox yview $pos
}

# If the user uses scanning to change filepos

proc scany_filepos {a b} {
    global nr_files
    change_filepos [expr round($a*$nr_files)]
}

proc scanx_filepos {a b} {
    .l.filebox xview 0
}

# If user requests a change of listfilepos.

proc change_listpos {pos} {
    global nr_listfiles
    if {[expr $pos >= $nr_listfiles-15]} {set pos [expr $nr_listfiles-15]}
    if {[expr $pos < 0]} {set pos 0}
    .l.listscroll set $nr_listfiles 15 $pos [expr $pos+14]
    .l.listbox yview $pos
}

# If the user uses scanning to change filepos

proc scany_listpos {a b} {
    global nr_listfiles
    change_listpos [expr round($a*$nr_listfiles)]
}

proc scanx_listpos {a b} {
    .l.listbox xview 0
}

# Load from a marked list

proc load_marked {box loadit dirs} {
    global browse_state

    set list [lsort -integer [$box curselection]]
    set len [llength $list]
    if {[expr $len > 0]} {
	if {[expr $len > 1]} {
	    set browse_state 1
	}
	set first [lindex $list 0]
	if {[expr $first >= $dirs]} {
	    $loadit $first
	}
	if {[expr $len > 1]} {
	    $box selection clear $first
	} else {
	    if {[expr $browse_state == 1]} {
		$box selection clear 0 end
	    }
	}
    }
}
