# command box (one for each size)

proc mk_control {w} {
    global ww_playstop ww_next ww_prev ww_posscroll

    # Control buttons
    frame $w.controlbox
    set w_playstop $w.controlbox.playstop
    lappend ww_playstop $w_playstop
    button $w_playstop -bitmap play\
	    -command "c_playstop" -padx 3 -state disabled
    set w_posscroll $w.controlbox.posscroll
    lappend ww_posscroll $w_posscroll
    scrollbar $w_posscroll -orient horizontal -width 18\
	    -relief sunken -command "change_songpos"
    set w_next $w.controlbox.next
    lappend ww_next $w_next
    button $w_next -text "Next" -command "c_next" -bitmap next
    set w_prev $w.controlbox.prev
    lappend ww_prev $w_prev
    button $w_prev -text "Previous" -command "c_prev" -bitmap prev
    pack $w.controlbox.playstop -side left -pady 2 -padx 2 -fill y
    pack $w.controlbox.posscroll -side left -pady 2 -padx 2 -fill x -expand yes
    pack $w.controlbox.prev $w.controlbox.next -side left -pady 2 -padx 2\
	    -fill y
}

proc mk_expand {w} {
    menubutton $w -bitmap resize -menu $w.m
    menu $w.m
    $w.m add radio -label "Chubby" -variable window_size\
	    -value "chubby" -command "update_window_size"
    $w.m add radio -label "Slim" -variable window_size\
	    -value "slim" -command "update_window_size"
    $w.m add radio -label "Normal" -variable window_size\
	    -value "normal" -command "update_window_size"
    $w.m add radio -label "Verbose" -variable window_size\
	    -value "verbose" -command "update_window_size"
}

# Expand menu + menubar + time

proc mk_expandmenutimebox {w} {
    global w_menu_file w_menu_file_nr_next w_menu_file_nr_prev\
	    w_menu_file_nr_load w_menu_settings\
	    w_menu_settings_nr_options

    frame $w
    frame $w.expandframe -bd 2 -relief raised
    mk_expand $w.expandframe.expand
    pack $w.expandframe.expand
    frame $w.mbar -relief raised -bd 2
    frame $w.timebox
    
    # Menu bar
    menubutton $w.mbar.mf -text "File..." -menu $w.mbar.mf.m
    menubutton $w.mbar.mo -text "Edit..." -menu $w.mbar.mo.m

    set w_menu_file $w.mbar.mf.m
    menu $w_menu_file
    set w_menu_file_nr_load 0

    $w_menu_file add command -label "Load..." -accelerator l\
	    -command {global w_load; $w_load invoke}
    set w_menu_file_nr_next 1
    $w_menu_file add command -label "Next" -accelerator n\
	    -command {global ww_next; [lindex $ww_next 0] invoke}
    set w_menu_file_nr_prev 2
    $w_menu_file add command -label "Previous  " -accelerator p\
	    -command {global ww_prev; [lindex $ww_prev 0] invoke}
    $w_menu_file add sep
    $w_menu_file add command -label "About" -command {
	show_message "About Mod..." \
"Mod is (C) 1994, 1995 Mikael Nordqvist
and freely distributable under
GNU Public Licence version 2.

The following module formats are supported:

Protracker 3.0 compatibles with up to 32 voices (MOD)
Ultratracker 1.60 (ULT)
Multitracker 1.01a (MTM)
Scream Tracker 3.01beta (S3M)" 600
    }
    $w_menu_file add command -label "Quit" -command "c_quit" -accelerator q

    set w_menu_settings $w.mbar.mo.m
    menu $w_menu_settings
    set w_menu_settings_nr_options 0
    $w_menu_settings add command -label "Options"\
	    -command "edit_global_options"

    pack $w.mbar.mf $w.mbar.mo -side left -fill x -expand yes -padx 2
    tk_menuBar $w.mbar $w.mbar.mf $w.mbar.mo

    # Time
    label $w.timebox.time -text "Time"
    label $w.timebox.timei -textvariable m_time -anchor c -relief sunken\
	    -width 6
    pack $w.timebox.time $w.timebox.timei -side left -fill x -expand yes
    
    # Ok, pack it.
    pack $w.expandframe -side left -padx 2 -pady 3
    pack $w.mbar $w.timebox -side left -pady 3 -padx 2 -fill x -expand yes
}

# Status

proc mk_statusbox {w} {
    frame $w
    label $w.status -text "Status"
    frame $w.statusvoid
    label $w.statusi -textvariable m_status -anchor w -relief sunken -width 27
    pack $w.status -side left -padx 2
    pack $w.statusvoid -fill x -expand yes -padx 2
    pack $w.statusi -padx 2
}

# Song- and filename information

proc mk_songfilenamebox {w} {
    frame $w
    frame $w.t
    frame $w.i

    label $w.t.song -text "Song"
    label $w.t.file -text "File"
    label $w.i.song -textvariable m_song -anchor w -relief sunken -width 28
    label $w.i.file -textvariable m_file -anchor w -relief sunken -width 28
    
    pack $w.t.song $w.t.file -anchor w -pady 2 -side top
    pack $w.i.song $w.i.file -anchor w -pady 2 -fill x 
    pack $w.t -side left -padx 2 -expand yes
    pack $w.i -side left -padx 2 -fill x

#    pack .song .file -side top -anchor w -in .t1 -pady 2
#    pack .songi .filei -anchor w -in .i1 -fill x -pady 2
}


# Buttons: Load + Comment + Infofile

proc mk_buttonbox {w} {
    global w_load w_viewcomment w_viewinfofile

    frame $w
    set w_load $w.load
    button $w_load -text "Load..." -command "show_load"
    set w_viewcomment $w.viewcomment
    button $w_viewcomment -text "Comment" -state disabled\
	    -command "c_viewcomment"
    set w_viewinfofile $w.viewinfofile
    button $w_viewinfofile -text "Infofile" -state disabled\
	    -command "c_viewinfofile"
    pack $w.load $w.viewcomment $w.viewinfofile -side left\
	    -pady 2 -padx 2 -fill x -expand yes
}

# Volume + mute

proc mk_volumebox {w} {
    global w_mute w_volscale bgcol selfgcol

    frame $w
    label $w.volume -text "Volume" -anchor w
    set w_volscale $w.volscale
    scale $w_volscale -from 0 -to 100 -orient horizontal -showvalue no\
	    -activebackground $bgcol -command "set mute_state 0; c_volume"
    set w_mute $w.mute
    checkbutton $w_mute -text "Mute" -variable mute_state -relief raised\
	    -command "c_setmute"
    pack $w.volume -side left -pady 1
    pack $w.volscale $w.mute -side left -fill both -pady 1 -padx 4 -expand yes
    pack $w.mute -fill both -pady 1 -padx 2 -expand yes

    bind . m {global w_mute; $w_mute invoke}
}

# Module information

proc mk_infobox {w} {
    frame $w
    frame $w.l
    frame $w.r

    # Statics
    frame $w.l.t
    label $w.l.t.type -text "Type"
    label $w.l.t.voices -text "Voices"
    label $w.l.t.samples -text "Samples"
    label $w.l.t.size -text "Size"
    label $w.l.t.filesize -text "Filesize"
    pack $w.l.t.type $w.l.t.voices $w.l.t.samples $w.l.t.size $w.l.t.filesize\
	    -side top -anchor w -pady 2
    
    frame $w.l.i
    label $w.l.i.type -textvariable m_type -anchor c -relief sunken -width 6
    label $w.l.i.voices -textvariable m_voices -anchor c -relief sunken\
	    -width 6
    label $w.l.i.samples -textvariable m_samples -anchor c -relief sunken\
	    -width 6
    label $w.l.i.size -textvariable m_size -anchor c -relief sunken -width 6
    label $w.l.i.filesize -textvariable m_filesize -anchor c -relief sunken\
	    -width 6
    pack $w.l.i.type $w.l.i.voices $w.l.i.samples $w.l.i.size $w.l.i.filesize\
	    -anchor w -pady 2 -padx 2
    
    pack $w.l.t $w.l.i -side left

    # Dynamics
    frame $w.r.t
    label $w.r.t.songpos -text "Songpos"
    label $w.r.t.pattern -text "Pattern"
    label $w.r.t.line -text "Line"
    label $w.r.t.speed -text "Speed"
    label $w.r.t.tempo -text "Tempo"
    pack $w.r.t.songpos $w.r.t.pattern $w.r.t.line $w.r.t.speed $w.r.t.tempo\
	    -side top -anchor w -pady 2 -padx 1
    
    frame $w.r.i
    label $w.r.i.songpos -textvariable m_songpos -anchor c -relief sunken\
	    -width 8
    label $w.r.i.pattern -textvariable m_pattern -anchor c -relief sunken\
	    -width 8
    label $w.r.i.line -textvariable m_line -anchor c -relief sunken -width 8
    label $w.r.i.speed -textvariable m_speed -anchor c -relief sunken -width 8
    label $w.r.i.tempo -textvariable m_tempo -anchor c -relief sunken -width 8
    pack $w.r.i.songpos $w.r.i.pattern $w.r.i.line $w.r.i.speed $w.r.i.tempo\
	    -anchor w -fill x -pady 2 -padx 4

    pack $w.r.t $w.r.i -side left

    # Pack it
    pack $w.r $w.l -side left
}

# Sample information

proc mk_samplebox {w} {
    global w_samplebox w_samplelistbox w_samplescroll fixfont fgcol bgcol

    set w_samplebox $w
    frame $w -relief raised -bd 2
    frame $w.f
    frame $w.f.t
    frame $w.f.b

    label $w.f.t.sampleheader -font $fixfont -anchor w\
       -text " # Samplename                    Size Volm Loop Tune Bits Type "
    pack $w.f.t.sampleheader -anchor w
    
    set w_samplelistbox $w.f.b.samplebox
    set w_samplescroll $w.f.b.samplescroll

    listbox $w_samplelistbox -width 66 -height 8\
	    -font $fixfont -relief sunken\
	    -bd 2 -yscroll "$w_samplescroll set" -selectmode single\
	    -selectbackground $bgcol -selectforeground $fgcol\
	    -selectborderwidth 0 -exportselection no
    scrollbar $w_samplescroll -orient vertical -width 15 -relief sunken\
	    -command "$w_samplelistbox yview"
    pack $w.f.b.samplebox -side left -pady 4 -padx 2 -anchor w\
	    -expand yes -fill y
    pack $w.f.b.samplescroll -side left -fill both -pady 4 -padx 2

    pack $w.f.t -anchor w -padx 2
    pack $w.f.b -expand yes -fill y
    pack $w.f -expand yes -fill y

    bind $w_samplelistbox <Button1-Motion> {break}
    bind $w_samplelistbox <Shift-1> {break}
    bind $w_samplelistbox <Button-1> {break}
    bind $w_samplelistbox <Shift-Button1-Motion> {break}
}

# Voices (incomplete/old)

proc mk_voices {w} {
    frame .voiceinfo -relief raised -bd 2
    
    foreach i {1 2 3 4} {
	frame .voicef$i
	listbox .voicebox$i -geometry 16x9 -font $fixfont -relief sunken -bd 2\
		-yscroll scan_samplepos
	label .voicelabel$i -text "Voice $i"
	pack .voicelabel$i .voicebox$i -in .voicef$i
	
	pack .voicef$i -in .voiceinfo -side left -expand yes -pady 4
    }
}


### Functions to create the screens

proc mk_normalscreen {w} {
    global w_normal
    
    set w_normal $w
    frame $w
    frame $w.t
    frame $w.t.l -relief raised -bd 2
    frame $w.t.r -relief raised -bd 2
    
    mk_expandmenutimebox $w.t.l.menutimebox
    mk_statusbox $w.t.l.statusbox
    set w_controlboxnormal $w.t.l.controlbox
    frame $w_controlboxnormal
    mk_control $w_controlboxnormal
    pack $w_controlboxnormal.controlbox -fill x
    mk_songfilenamebox $w.t.l.songfilenamebox
    mk_buttonbox $w.t.l.buttonbox
    pack $w.t.l.menutimebox $w.t.l.statusbox\
	    $w.t.l.controlbox $w.t.l.songfilenamebox\
	    $w.t.l.buttonbox\
	    -anchor w -fill x -expand yes
    
    mk_volumebox $w.t.r.volumebox
    mk_infobox $w.t.r.infobox
    pack $w.t.r.volumebox $w.t.r.infobox -fill x -padx 2 -pady 2
    pack $w.t.l $w.t.r -side left -fill y -expand yes
    pack $w.t -expand no
    mk_samplebox $w.samplebox
}


proc mk_slimscreen {w} {
    global w_slim w_loadslim

    set w_slim $w
    frame $w -bd 2 -relief raised

    frame $w.expandframe -bd 2 -relief raised
    mk_expand $w.expandframe.expand
    pack $w.expandframe.expand
    set w_loadslim $w.load
    button $w_loadslim -bitmap load -command "show_load"
    label $w.file -textvariable m_file -anchor w -relief sunken -width 24

    set w_controlboxslim $w.controlbox
    frame $w_controlboxslim -width 216
    pack propagate $w_controlboxslim false
    mk_control $w_controlboxslim
    pack $w_controlboxslim.controlbox -fill x -expand yes
    frame $w.timebox
    label $w.timebox.time -textvariable m_time -anchor c\
	    -relief sunken -width 6
    pack $w.timebox.time -side left -fill both -expand yes

    pack $w.expandframe $w.load $w.file -padx 2 -pady 2 -side left
    pack $w.file -fill y -expand yes -side left
    pack $w_controlboxslim -expand yes -fill both -anchor c -side left
    pack $w.timebox -fill both -padx 2 -pady 2 -expand yes -side left
}


proc mk_chubbyscreen {w} {
    global w_chubby w_loadchubby

    set w_chubby $w
    frame $w -width 600 -bd 2 -relief raised
    frame $w.t
    frame $w.b

    # Top
    frame $w.t.expandframe -bd 2 -relief raised
    mk_expand $w.t.expandframe.expand
    pack $w.t.expandframe.expand
    set w_loadchubby $w.t.load
    button $w_loadchubby -bitmap load -command "show_load"
    label $w.t.file -textvariable m_file -anchor w -relief sunken
    pack $w.t.expandframe $w.t.load -padx 2 -pady 2 -side left
    pack $w.t.file -fill both -padx 2 -pady 2 -side left -expand yes

    # Bottom
    set w_controlboxchubby $w.b.controlbox
    frame $w_controlboxchubby -width 210
    pack propagate $w_controlboxchubby false
    mk_control $w_controlboxchubby 
    pack $w_controlboxchubby.controlbox -fill x -expand yes
    frame $w.b.timebox
    label $w.b.timebox.time -textvariable m_time -anchor c\
	    -relief sunken -width 6
    pack $w.b.timebox.time -side left -fill both -expand yes
    pack $w.b.controlbox -expand yes -fill both -side left
    pack $w.b.timebox -fill both -padx 2 -pady 2

    pack $w.t $w.b -expand yes -fill x
}


#### Ok. Do it. ####

frame .m
mk_normalscreen .m.normal
mk_slimscreen .m.slim
mk_chubbyscreen .m.chubby

### Set up keybindings

bind . q {c_quit}
bind . l {global w_load; $w_load invoke}

bind . <space> {global ww_next; [lindex $ww_next 0] invoke}
bind . n {global ww_next; [lindex $ww_next 0] invoke}
bind . p {global ww_prev; [lindex $ww_prev 0] invoke}

bind . <Return> {global ww_playstop; [lindex $ww_playstop 0] invoke}
bind . + {
    global mute_state w_volscale
    $w_volscale set [expr [$w_volscale get]+5]
    set mute_state 0
    c_volume [$w_volscale get]
}
bind . - {
    global mute_state w_volscale
    $w_volscale set [expr [$w_volscale get]-5]
    set mute_state 0
    c_volume [$w_volscale get]
}
bind . <Next> {
    global ww_posscroll
    change_songpos [expr [lindex [[lindex $ww_posscroll 0] get] 2]+1]
}
bind . <Prior> {
    global ww_posscroll
    change_songpos [expr [lindex [[lindex $ww_posscroll 0] get] 2]-1]
}
bind . <Home> {c_restart}
bind . r {c_restart}
bind . <Down> {
    global w_samplelistbox
    $w_samplelistbox yview scroll 1 units

}
bind . <Up> {
    global w_samplelistbox
    $w_samplelistbox yview scroll -1 units
}
#bind . <Shift-Up> {
#    global window_size w_samplelistbox nr_visible_samples
#    if {[expr [string compare "verbose" $window_size] == 0]} {
#	if {[expr $nr_visible_samples > 3]} {
#	    set nr_visible_samples [expr $nr_visible_samples-1]
#	}
#	$w_samplelistbox configure -height $nr_visible_samples
#	wm maxsize . 0 $nr_visible_samples
#    }
#}
#bind . <Shift-Down> {
#    global window_size w_samplelistbox nr_visible_samples
#    if {[expr [string compare "verbose" $window_size] == 0]} {
#	if {[expr $nr_visible_samples < 31]} {
#	    set nr_visible_samples [expr $nr_visible_samples+1]
#	}
#	$w_samplelistbox configure -height $nr_visible_samples
#	wm maxsize . 0 $nr_visible_samples
#    }
#}

bind . <less> {
    global window_size
    switch $window_size {
	"slim" {
	    set window_size chubby
	    update_window_size
	}
	"normal" {
	    set window_size slim
	    update_window_size
	}
	"verbose" {
	    set window_size normal
	    update_window_size
	}
    }
}

bind . <greater> {
    global window_size
    switch $window_size {
	"chubby" {
	    set window_size slim
	    update_window_size
	}
	"slim" {
	    set window_size normal
	    update_window_size
	}
	"normal" {
	    set window_size verbose
	    update_window_size
	}
    }
}

### Functions

proc nop args {}

proc update_window_size {} {
    global window_size w_samplelistbox prev_window_size

#    if {[expr [string compare "verbose"  $window_size] != 0]} {
#	$w_samplelistbox configure -setgrid no
#    }
    switch $window_size {
	"chubby" {
	    global w_normal w_slim w_chubby w_samplebox

	    pack forget $w_slim $w_normal $w_samplebox
            pack $w_chubby -fill both -side left
	    wm title . "Mod (chubby)"
	    wm resizable . no no
	}
	"slim" {
	    global w_normal w_slim w_chubby w_samplebox

            pack forget $w_normal $w_chubby $w_samplebox
	    pack $w_slim -fill both -side left
	    wm title . "Mod (slim)"
	    wm resizable . no no
	}
	"normal" {
	    global w_normal w_slim w_chubby w_samplebox mod_version

            pack forget $w_slim $w_chubby $w_samplebox
	    pack $w_normal
	    wm title . "Mod $mod_version"
	    wm resizable . no no
	}
	"verbose" {
	    global w_normal w_slim w_chubby w_samplebox mod_version\
		    nr_visible_samples
    
            pack forget $w_slim $w_chubby

	    wm title . "Mod $mod_version"
#	    wm resizable . no yes
	    wm resizable . no no
#	    $w_samplelistbox configure -setgrid yes
	    $w_samplelistbox configure -height $nr_visible_samples
	    pack $w_normal
	    pack $w_samplebox -expand yes -fill both
#	    wm geometry . ""
#	    wm maxsize . 0 $nr_visible_samples
	}
    }
#    update
#    update idletasks
#    if {[expr [string compare "verbose"  $window_size] != 0]} {
#	wm geometry . ""
#    }
    set prev_window_size $window_size
}

# If user requests a change of songpos.

proc change_songpos {pos} {
    global ww_posscroll

    set_songpos $pos
    c_changesongpos [lindex [[lindex $ww_posscroll 0] get] 2]
    update idletasks
}

# Set the songpos slider correctly

proc set_songpos {pos} {
    global ww_posscroll songlength

    if {[expr $pos < 0]} {set pos 0}
    if {[expr $pos >= $songlength]} {set pos [expr $songlength-1]}
    foreach a "$ww_posscroll" {
	$a set $songlength 6 $pos $pos
    }
}
